
Selected circuits
===================
 - **Circuit**: 8-bit unsigned adders
 - **Selection criteria**: pareto optimal sub-set wrt. pwr and ep parameters

Parameters of selected circuits
----------------------------

| Circuit name | MAE<sub>%</sub> | WCE<sub>%</sub> | EP<sub>%</sub> | MRE<sub>%</sub> | MSE | Download |
| --- |  --- | --- | --- | --- | --- | --- | 
| add8u_0FP | 0.00 | 0.00 | 0.00 | 0.00 | 0 |  [[Verilog](add8u_0FP.v)]  [[C](add8u_0FP.c)] |
| add8u_5R3 | 0.039 | 0.20 | 25.00 | 0.14 | 0.2 |  [[Verilog](add8u_5R3.v)] [[Verilog<sub>PDK45</sub>](add8u_5R3_pdk45.v)] [[C](add8u_5R3.c)] |
| add8u_5NQ | 0.16 | 0.98 | 34.38 | 0.40 | 2.5 |  [[Verilog](add8u_5NQ.v)] [[Verilog<sub>PDK45</sub>](add8u_5NQ_pdk45.v)] [[C](add8u_5NQ.c)] |
| add8u_5QL | 0.16 | 0.59 | 43.75 | 0.40 | 1.5 |  [[Verilog](add8u_5QL.v)] [[Verilog<sub>PDK45</sub>](add8u_5QL_pdk45.v)] [[C](add8u_5QL.c)] |
| add8u_00Y | 0.76 | 3.91 | 49.22 | 1.95 | 56 |  [[Verilog](add8u_00Y.v)]  [[C](add8u_00Y.c)] |
| add8u_5ME | 0.35 | 1.37 | 71.88 | 0.94 | 6.5 |  [[Verilog](add8u_5ME.v)] [[Verilog<sub>PDK45</sub>](add8u_5ME_pdk45.v)] [[C](add8u_5ME.c)] |
| add8u_5G6 | 0.72 | 2.93 | 85.94 | 1.91 | 26 |  [[Verilog](add8u_5G6.v)] [[Verilog<sub>PDK45</sub>](add8u_5G6_pdk45.v)] [[C](add8u_5G6.c)] |
| add8u_063 | 15.29 | 47.66 | 99.61 | 37.63 | 9126 |  [[Verilog](add8u_063.v)]  [[C](add8u_063.c)] |
    
Parameters
--------------
![Parameters figure](fig.png)

References
--------------
   - V. Mrazek, Z. Vasicek and R. Hrbacek, "Role of circuit representation in evolutionary design of energy-efficient approximate circuits" in IET Computers & Digital Techniques, vol. 12, no. 4, pp. 139-149, 7 2018. doi: [10.1049/iet-cdt.2017.0188](https://dx.doi.org/10.1049/iet-cdt.2017.0188)
   - V. Mrazek, R. Hrbacek, Z. Vasicek and L. Sekanina, "EvoApprox8b: Library of approximate adders and multipliers for circuit design and benchmarking of approximation methods". Design, Automation & Test in Europe Conference & Exhibition (DATE), 2017, Lausanne, 2017, pp. 258-261. doi: [10.23919/DATE.2017.7926993](https://dx.doi.org/10.23919/DATE.2017.7926993)

             