
Selected circuits
===================
 - **Circuit**: 8-bit unsigned adders
 - **Selection criteria**: pareto optimal sub-set wrt. pwr and mae parameters

Parameters of selected circuits
----------------------------

| Circuit name | MAE<sub>%</sub> | WCE<sub>%</sub> | EP<sub>%</sub> | MRE<sub>%</sub> | MSE | Download |
| --- |  --- | --- | --- | --- | --- | --- | 
| add8u_0FP | 0.00 | 0.00 | 0.00 | 0.00 | 0 |  [[Verilog](add8u_0FP.v)]  [[C](add8u_0FP.c)] |
| add8u_5R3 | 0.039 | 0.20 | 25.00 | 0.14 | 0.2 |  [[Verilog](add8u_5R3.v)] [[Verilog<sub>PDK45</sub>](add8u_5R3_pdk45.v)] [[C](add8u_5R3.c)] |
| add8u_5QL | 0.16 | 0.59 | 43.75 | 0.40 | 1.5 |  [[Verilog](add8u_5QL.v)] [[Verilog<sub>PDK45</sub>](add8u_5QL_pdk45.v)] [[C](add8u_5QL.c)] |
| add8u_5LT | 0.33 | 1.37 | 71.88 | 0.91 | 6.0 |  [[Verilog](add8u_5LT.v)] [[Verilog<sub>PDK45</sub>](add8u_5LT_pdk45.v)] [[C](add8u_5LT.c)] |
| add8u_5HQ | 0.68 | 2.93 | 85.74 | 1.80 | 24 |  [[Verilog](add8u_5HQ.v)] [[Verilog<sub>PDK45</sub>](add8u_5HQ_pdk45.v)] [[C](add8u_5HQ.c)] |
| add8u_5SY | 1.05 | 3.12 | 94.14 | 2.93 | 44 |  [[Verilog](add8u_5SY.v)] [[Verilog<sub>PDK45</sub>](add8u_5SY_pdk45.v)] [[C](add8u_5SY.c)] |
| add8u_099 | 2.03 | 6.64 | 97.07 | 6.23 | 164 |  [[Verilog](add8u_099.v)]  [[C](add8u_099.c)] |
| add8u_006 | 4.92 | 17.97 | 98.77 | 14.58 | 960 |  [[Verilog](add8u_006.v)]  [[C](add8u_006.c)] |
| add8u_08V | 9.88 | 30.47 | 99.45 | 24.87 | 3803 |  [[Verilog](add8u_08V.v)]  [[C](add8u_08V.c)] |
| add8u_063 | 15.29 | 47.66 | 99.61 | 37.63 | 9126 |  [[Verilog](add8u_063.v)]  [[C](add8u_063.c)] |
    
Parameters
--------------
![Parameters figure](fig.png)

References
--------------
   - V. Mrazek, Z. Vasicek and R. Hrbacek, "Role of circuit representation in evolutionary design of energy-efficient approximate circuits" in IET Computers & Digital Techniques, vol. 12, no. 4, pp. 139-149, 7 2018. doi: [10.1049/iet-cdt.2017.0188](https://dx.doi.org/10.1049/iet-cdt.2017.0188)
   - V. Mrazek, R. Hrbacek, Z. Vasicek and L. Sekanina, "EvoApprox8b: Library of approximate adders and multipliers for circuit design and benchmarking of approximation methods". Design, Automation & Test in Europe Conference & Exhibition (DATE), 2017, Lausanne, 2017, pp. 258-261. doi: [10.23919/DATE.2017.7926993](https://dx.doi.org/10.23919/DATE.2017.7926993)

             