
Selected circuits
===================
 - **Circuit**: 8-bit unsigned adders
 - **Selection criteria**: pareto optimal sub-set wrt. pwr and wce parameters

Parameters of selected circuits
----------------------------

| Circuit name | MAE<sub>%</sub> | WCE<sub>%</sub> | EP<sub>%</sub> | MRE<sub>%</sub> | MSE | Download |
| --- |  --- | --- | --- | --- | --- | --- | 
| add8u_0FP | 0.00 | 0.00 | 0.00 | 0.00 | 0 |  [[Verilog](add8u_0FP.v)]  [[C](add8u_0FP.c)] |
| add8u_4T8 | 0.098 | 0.20 | 50.00 | 0.27 | 0.5 |  [[Verilog](add8u_4T8.v)]  [[C](add8u_4T8.c)] |
| add8u_01R | 0.21 | 0.59 | 75.00 | 0.61 | 2.0 |  [[Verilog](add8u_01R.v)]  [[C](add8u_01R.c)] |
| add8u_5EZ | 0.45 | 1.37 | 87.50 | 1.23 | 8.0 |  [[Verilog](add8u_5EZ.v)] [[Verilog<sub>PDK45</sub>](add8u_5EZ_pdk45.v)] [[C](add8u_5EZ.c)] |
| add8u_1DK | 0.88 | 2.34 | 93.75 | 2.54 | 30 |  [[Verilog](add8u_1DK.v)] [[Verilog<sub>PDK45</sub>](add8u_1DK_pdk45.v)] [[C](add8u_1DK.c)] |
| add8u_2XT | 1.64 | 4.30 | 96.88 | 4.57 | 100 |  [[Verilog](add8u_2XT.v)]  [[C](add8u_2XT.c)] |
| add8u_09K | 3.38 | 8.98 | 99.22 | 9.06 | 420 |  [[Verilog](add8u_09K.v)]  [[C](add8u_09K.c)] |
| add8u_0CA | 6.45 | 16.60 | 99.22 | 16.82 | 1488 |  [[Verilog](add8u_0CA.v)]  [[C](add8u_0CA.c)] |
| add8u_08V | 9.88 | 30.47 | 99.45 | 24.87 | 3803 |  [[Verilog](add8u_08V.v)]  [[C](add8u_08V.c)] |
| add8u_063 | 15.29 | 47.66 | 99.61 | 37.63 | 9126 |  [[Verilog](add8u_063.v)]  [[C](add8u_063.c)] |
    
Parameters
--------------
![Parameters figure](fig.png)

References
--------------
   - V. Mrazek, Z. Vasicek and R. Hrbacek, "Role of circuit representation in evolutionary design of energy-efficient approximate circuits" in IET Computers & Digital Techniques, vol. 12, no. 4, pp. 139-149, 7 2018. doi: [10.1049/iet-cdt.2017.0188](https://dx.doi.org/10.1049/iet-cdt.2017.0188)
   - V. Mrazek, R. Hrbacek, Z. Vasicek and L. Sekanina, "EvoApprox8b: Library of approximate adders and multipliers for circuit design and benchmarking of approximation methods". Design, Automation & Test in Europe Conference & Exhibition (DATE), 2017, Lausanne, 2017, pp. 258-261. doi: [10.23919/DATE.2017.7926993](https://dx.doi.org/10.23919/DATE.2017.7926993)

             