
Selected circuits
===================
 - **Circuit**: 12-bit unsigned multiplier
 - **Selection criteria**: pareto optimal sub-set wrt. pwr and mae parameters

Parameters of selected circuits
----------------------------

| Circuit name | MAE<sub>%</sub> | WCE<sub>%</sub> | EP<sub>%</sub> | MRE<sub>%</sub> | MSE | Download |
| --- |  --- | --- | --- | --- | --- | --- | 
| mul12u_1BG | 0.00 | 0.00 | 0.00 | 0.00 | 0 |  [[Verilog](mul12u_1BG.v)] [[Verilog<sub>PDK45</sub>](mul12u_1BG_pdk45.v)] [[C](mul12u_1BG.c)] |
| mul12u_2EC | 0.0000075 | 0.00003 | 50.00 | 0.00062 | 3.8 |  [[Verilog](mul12u_2EC.v)] [[Verilog<sub>PDK45</sub>](mul12u_2EC_pdk45.v)] [[C](mul12u_2EC.c)] |
| mul12u_2ED | 0.000025 | 0.0001 | 68.75 | 0.0019 | 34 |  [[Verilog](mul12u_2ED.v)] [[Verilog<sub>PDK45</sub>](mul12u_2ED_pdk45.v)] [[C](mul12u_2ED.c)] |
| mul12u_2EF | 0.00019 | 0.00077 | 89.06 | 0.012 | 1574 |  [[Verilog](mul12u_2EF.v)] [[Verilog<sub>PDK45</sub>](mul12u_2EF_pdk45.v)] [[C](mul12u_2EF.c)] |
| mul12u_2EH | 0.0011 | 0.0046 | 96.48 | 0.057 | 50190 |  [[Verilog](mul12u_2EH.v)] [[Verilog<sub>PDK45</sub>](mul12u_2EH_pdk45.v)] [[C](mul12u_2EH.c)] |
| mul12u_0UD | 0.0058 | 0.025 | 99.99 | 0.30 | 14611.25e2 |  [[Verilog](mul12u_0UD.v)] [[Verilog<sub>PDK45</sub>](mul12u_0UD_pdk45.v)] [[C](mul12u_0UD.c)] |
| mul12u_2DH | 0.073 | 0.29 | 99.84 | 1.67 | 18304.091e4 |  [[Verilog](mul12u_2DH.v)] [[Verilog<sub>PDK45</sub>](mul12u_2DH_pdk45.v)] [[C](mul12u_2DH.c)] |
| mul12u_33U | 0.38 | 1.51 | 99.86 | 5.01 | 56232.128e5 |  [[Verilog](mul12u_33U.v)] [[Verilog<sub>PDK45</sub>](mul12u_33U_pdk45.v)] [[C](mul12u_33U.c)] |
| mul12u_2Z6 | 2.72 | 10.89 | 99.95 | 26.78 | 27178.297e7 |  [[Verilog](mul12u_2Z6.v)] [[Verilog<sub>PDK45</sub>](mul12u_2Z6_pdk45.v)] [[C](mul12u_2Z6.c)] |
| mul12u_35V | 18.74 | 74.95 | 99.95 | 87.98 | 15865.376e9 |  [[Verilog](mul12u_35V.v)]  [[C](mul12u_35V.c)] |
    
Parameters
--------------
![Parameters figure](fig.png)

References
--------------
   - V. Mrazek, Z. Vasicek and R. Hrbacek, "Role of circuit representation in evolutionary design of energy-efficient approximate circuits" in IET Computers & Digital Techniques, vol. 12, no. 4, pp. 139-149, 7 2018. doi: [10.1049/iet-cdt.2017.0188](https://dx.doi.org/10.1049/iet-cdt.2017.0188)
   - V. Mrazek, Z. Vasicek, L. Sekanina, H. Jiang and J. Han, "Scalable Construction of Approximate Multipliers With Formally Guaranteed Worst Case Error" in IEEE Transactions on Very Large Scale Integration (VLSI) Systems, vol. 26, no. 11, pp. 2572-2576, Nov. 2018. doi: [10.1109/TVLSI.2018.2856362](https://dx.doi.org/10.1109/TVLSI.2018.2856362)

             