
Selected circuits
===================
 - **Circuit**: 8-bit signed multiplier
 - **Selection criteria**: pareto optimal sub-set wrt. pwr and wce parameters

Parameters of selected circuits
----------------------------

| Circuit name | MAE<sub>%</sub> | WCE<sub>%</sub> | EP<sub>%</sub> | MRE<sub>%</sub> | MSE | Download |
| --- |  --- | --- | --- | --- | --- | --- | 
| mul8s_1KV8 | 0.00 | 0.00 | 0.00 | 0.00 | 0 |  [[Verilog](mul8s_1KV8.v)] [[Verilog<sub>PDK45</sub>](mul8s_1KV8_pdk45.v)] [[C](mul8s_1KV8.c)] |
| mul8s_1KVA | 0.0018 | 0.0076 | 50.00 | 0.28 | 3.8 |  [[Verilog](mul8s_1KVA.v)] [[Verilog<sub>PDK45</sub>](mul8s_1KVA_pdk45.v)] [[C](mul8s_1KVA.c)] |
| mul8s_1KVB | 0.0064 | 0.026 | 68.75 | 0.90 | 34 |  [[Verilog](mul8s_1KVB.v)] [[Verilog<sub>PDK45</sub>](mul8s_1KVB_pdk45.v)] [[C](mul8s_1KVB.c)] |
| mul8s_1KX2 | 0.019 | 0.075 | 81.25 | 2.53 | 248 |  [[Verilog](mul8s_1KX2.v)] [[Verilog<sub>PDK45</sub>](mul8s_1KX2_pdk45.v)] [[C](mul8s_1KX2.c)] |
| mul8s_1KR6 | 0.051 | 0.21 | 74.80 | 2.73 | 2746 |  [[Verilog](mul8s_1KR6.v)] [[Verilog<sub>PDK45</sub>](mul8s_1KR6_pdk45.v)] [[C](mul8s_1KR6.c)] |
| mul8s_1L2H | 0.081 | 0.39 | 74.61 | 4.41 | 5462 |  [[Verilog](mul8s_1L2H.v)] [[Verilog<sub>PDK45</sub>](mul8s_1L2H_pdk45.v)] [[C](mul8s_1L2H.c)] |
| mul8s_1L2D | 0.23 | 1.16 | 93.16 | 12.26 | 38236 |  [[Verilog](mul8s_1L2D.v)] [[Verilog<sub>PDK45</sub>](mul8s_1L2D_pdk45.v)] [[C](mul8s_1L2D.c)] |
| mul8s_1L1G | 0.52 | 2.66 | 97.75 | 27.44 | 191238 |  [[Verilog](mul8s_1L1G.v)] [[Verilog<sub>PDK45</sub>](mul8s_1L1G_pdk45.v)] [[C](mul8s_1L1G.c)] |
| mul8s_1KR3 | 3.08 | 12.30 | 98.05 | 135.77 | 72829.102e2 |  [[Verilog](mul8s_1KR3.v)] [[Verilog<sub>PDK45</sub>](mul8s_1KR3_pdk45.v)] [[C](mul8s_1KR3.c)] |
    
Parameters
--------------
![Parameters figure](fig.png)

References
--------------
   - V. Mrazek, Z. Vasicek, L. Sekanina, H. Jiang and J. Han, "Scalable Construction of Approximate Multipliers With Formally Guaranteed Worst Case Error" in IEEE Transactions on Very Large Scale Integration (VLSI) Systems, vol. 26, no. 11, pp. 2572-2576, Nov. 2018. doi: [10.1109/TVLSI.2018.2856362](https://dx.doi.org/10.1109/TVLSI.2018.2856362)

             